class Entry {
  String title; 
  int[] counts = new int[TIME_POINTS];
  PVector[] positions = new PVector[TIME_POINTS];
  color c;
  PVector currpos = new PVector(0, 0, 0);
  
  float size = 0.0;
  //float avgCount = 0.0;
  
  Entry(String title, int agent_index) {
    this.title = title;
    currpos.x = map(agent_index, 0, 500, 0, 2 * width);
    currpos.z = 0;
    
    for (int i = 0; i < TIME_POINTS; i++) {
      positions[i] = new PVector(currpos.x, 0, 0);
    }
  }
  
  void storeTimePoints(int i, int ct) { 
    if ( i >= 0 && i < TIME_POINTS) {
      counts[i] = ct;
      positions[i].y = map(ct, 0, 500, 0, height);
      positions[i].z = map(cos(time_index), -1, 1, 0, 1000);
    }
  }
  
  boolean updatePosition(int time_index) {
    size = map(positions[time_index].y, 0, 500, 1, 20);
    c = color(0,0,map(currpos.y, 0, height, 0, 255));
    currpos.z = positions[time_index].z;
    
    // which way are we incrementing y
    if ((currpos.y + system_rate) <= positions[time_index].y) { currpos.y += system_rate; } 
    else if ((currpos.y - system_rate) >= positions[time_index].y) { currpos.y -= system_rate; }
    
    if ((int)currpos.y >= positions[time_index].y - 5 && 
        (int)currpos.y <= positions[time_index].y + 5) { 
      return true;  
    } else { return false; }
  }

  void drawAgent() {
    pushMatrix();
    fill(c);
    translate(currpos.x, currpos.y, currpos.z);
    sphere(size);
    popMatrix();
  }
  
  
  void drawAgentHistory(int time_index) {
    if (time_index > 5) {
      for (int i = time_index - 5; i < time_index; i++) {
        pushMatrix();
        fill(c, 50); 
        translate(positions[i].x, positions[i].y, positions[i].z);
        sphere(size);
        popMatrix();
      }
    } else {
      for (int i = 0; i < time_index; i++) {
        pushMatrix();
        fill(c, 50); 
        translate(positions[i].x, positions[i].y, positions[i].z);
        sphere(size);
        popMatrix();
      }
    }
  }
}
